## bart-cuda 0.6.00

=== debian/changelog ===
bart-cuda (0.6.00-1+deb11u1) bullseye; urgency=medium

  * Team upload.
  * Cherry-pick relax-failing-unit-test.patch from release 0.7.00-1.
    Fixes FTBFS bug. Closes: #1070757.

 -- Santiago Vila <sanvila@debian.org>  Wed, 08 May 2024 16:40:00 +0200

bart-cuda (0.6.00-1) unstable; urgency=medium

  * Initial upload of this cuda enabled bart version
  * Path to change library path for cuda.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Fri, 18 Dec 2020 21:23:31 +0100
