=== debian/control ===
Source: bart-cuda
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
Section: contrib/science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libfftw3-dev,
               liblapack-dev | liblapack.so,
               libpng-dev,
               liblapacke-dev,
               nvidia-cuda-toolkit
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/bart
Vcs-Git: https://salsa.debian.org/med-team/bart.git
Homepage: https://mrirecon.github.io/bart/
Rules-Requires-Root: no

Package: bart-cuda
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: bart
Provides: bart
Replaces: bart
Suggests: octave-bart
Description: tools for computational magnetic resonance imaging
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging. It consists of a programming library and a toolbox
 of command-line programs. The library provides common operations on
 multi-dimensional arrays, Fourier and wavelet transforms, as well as
 generic implementations of iterative optimization algorithms. The
 command-line tools provide direct access to basic operations on
 multi-dimensional arrays as well as efficient implementations of
 many calibration and reconstruction algorithms for parallel imaging
 and compressed sensing.
 .
 This package provides BART with CUDA support.
