## bart-cuda 0.7.00

=== debian/changelog ===
bart-cuda (0.7.00-5) unstable; urgency=medium

  * Don't allow stderr for version check.
  * Turn off parallel build for determinism.
  * Arm the unit tests on s390x.
  * On Debian never use git version.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Sat, 01 Jan 2022 14:22:27 +0100

bart-cuda (0.7.00-4) unstable; urgency=medium

  * Team Upload.
  * Allow stderr for version check test

 -- Nilesh Patra <nilesh@debian.org>  Sat, 01 Jan 2022 16:08:30 +0530

bart-cuda (0.7.00-3) unstable; urgency=medium

  * Drop old compatibility patch.
  * Add workaround for compiler bug on armel and s390x.
  * Arm the unit tests on mips64el and s390x.
  * Fix cross-builds by reverting patch for deterministic archives.
  * Turn off parallel build for determinism.
  * Actually run test suite for bart-cuda.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 30 Dec 2021 16:28:18 +0100

bart-cuda (0.7.00-2) unstable; urgency=medium

  * Team upload.
    + Re-upload with .deb included

 -- Nilesh Patra <nilesh@debian.org>  Thu, 30 Dec 2021 23:04:29 +0530

bart-cuda (0.7.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Update upstream metadata.
  * Patch to relax failing unit test.
  * Patch to work around compiler bug.
  * Deterministic build.
  * Run test suite.
  * Don't update commands.txt.
  * Backport fixes for tests.

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)
  * No tab in license text (routine-update)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 26 Aug 2021 15:05:30 +0200
