=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libpng-dev,
                liblapacke-dev,
                nvidia-cuda-toolkit
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/
@@ -36,4 +36,3 @@
  and compressed sensing.
  .
  This package provides BART with CUDA support.
-
