=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,16 @@
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
-
 # Activate CUDA.
 export CUDA=1
 export CUDA_BASE=/usr/
+
+# set installation prefix
+export PREFIX=/usr/
+
+# turn of parallel builds here to make build deterministic
+export PARALLEL=1
+export PARALLEL_NJOBS=1
 
 # Some tests fail on the following architectures probably
 # due to minor differences in floating point processing.
@@ -15,7 +21,7 @@
 NOTEST_ARCHS=armel armhf mips mipsel hurd-i386 kfreebsd-i386 m68k powerpcspe sh4
 
 # For this architesture the test will be run but it will pass in any case even when errors occure
-PRINT_ERRORS_WHEN_TESTING=i386 mips64el s390x
+PRINT_ERRORS_WHEN_TESTING=i386
 
 %:
 	dh $@
