=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart-cuda
Restrictions: superficial

Tests: suite
Depends: bart-cuda, make
Architecture: amd64
Restrictions: allow-stderr
