## bart-cuda 0.8.00

=== debian/changelog ===
bart-cuda (0.8.00-2) unstable; urgency=medium

  [ Martin Uecker ]
  * Backport fixes for upstream (should also fix 32-bit archs)
  * Turn on tests for more archs.
  * Turn off some optimizations for some archs.
  * Update debian copyright.
  * Relax some flaky tests.

  [ Andreas Beckmann ]
  * Build-depend on nvidia-cuda-toolkit-gcc and don't hardcode a GCC version.

 -- Martin Uecker <uecker@tugraz.at>  Thu, 17 Nov 2022 20:35:27 +0530

bart-cuda (0.8.00-1) unstable; urgency=medium

  * New upstream version.
  * Turn off LTO build due to GCC bug #1017849.
  * Add std=c++14 to nvcc and use gcc-10 to fix build issues. (Closes: #1016625)
  * Standards-Version: 4.6.1.0
  * Mention machine learning in description.

 -- Martin Uecker  <uecker@tugraz.at>  Sun, 25 Sep 2022 14:34:15 +0200
