=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: bart-cuda
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
+Uploaders: Martin Uecker <uecker@tugraz.at>
 Section: contrib/science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -8,8 +8,8 @@
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev,
-               nvidia-cuda-toolkit
-Standards-Version: 4.6.0
+               nvidia-cuda-toolkit-gcc,
+Standards-Version: 4.6.1.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/
@@ -32,7 +32,7 @@
  generic implementations of iterative optimization algorithms. The
  command-line tools provide direct access to basic operations on
  multi-dimensional arrays as well as efficient implementations of
- many calibration and reconstruction algorithms for parallel imaging
- and compressed sensing.
+ many calibration and reconstruction algorithms for parallel imaging,
+ compressed sensing, and machine learning.
  .
  This package provides BART with CUDA support.
