=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
@@ -15,13 +15,20 @@
 export PARALLEL=1
 export PARALLEL_NJOBS=1
 
+# some archs require turning of some optimizations
+NOEXPOPT_ARCHS=arm64 ppc64el s390x ia64 powerpc ppc64 riscv64
+
+ifneq (,$(filter $(NOEXPOPT_ARCHS), $(DEB_BUILD_ARCH)))
+export DEB_CFLAGS_MAINT_APPEND = -fno-expensive-optimizations
+endif
+
 # Some tests fail on the following architectures probably
 # due to minor differences in floating point processing.
 # For now, just turn it off...
-NOTEST_ARCHS=armel armhf mips mipsel hurd-i386 kfreebsd-i386 m68k powerpcspe sh4
+NOTEST_ARCHS=hurd-i386 kfreebsd-i386 m68k powerpcspe sh4
 
 # For this architesture the test will be run but it will pass in any case even when errors occure
-PRINT_ERRORS_WHEN_TESTING=i386
+PRINT_ERRORS_WHEN_TESTING=armel armhf mips mipsel
 
 %:
 	dh $@
